org.apache.sis.metadata.iso.spatial

## Class DefaultGeometricObjects

- Object
- - AbstractMetadata
  - - ModifiableMetadata
    - - ISOMetadata
      - - DefaultGeometricObjects

- All Implemented Interfaces:
    Serializable, Cloneable, Emptiable, LenientComparable, IdentifiedObject, GeometricObjects

      public class DefaultGeometricObjects
      extends ISOMetadata
      implements GeometricObjects

  Number of objects, listed by geometric object type, used in the dataset. The following property is mandatory in a well-formed metadata according ISO 19115:
  `MD_GeometricObjects` `└─geometricObjectType……` Name of point and vector spatial objects used to locate zero-, one-, and two-dimensional spatial locations in the dataset.

  Limitations:

  - Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
  - Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.
  Since:
    0.3
  See Also:
    Serialized Form

  Defined in the `sis-metadata` module

- - ### Field Summary

    - ### Fields inherited from class ISOMetadata

      `identifiers`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultGeometricObjects()` Constructs an initially empty geometric objects.
    `DefaultGeometricObjects(GeometricObjects object)` Constructs a new instance initialized with the values from the specified metadata object.
    `DefaultGeometricObjects(GeometricObjectType geometricObjectType)` Creates a geometric object initialized to the given type.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static DefaultGeometricObjects` | `castOrCopy(GeometricObjects object)` Returns a SIS metadata implementation with the values of the given arbitrary implementation.
    `Integer` | `getGeometricObjectCount()` Returns the total number of the point or vector object type occurring in the dataset.
    `GeometricObjectType` | `getGeometricObjectType()` Returns the total number of the point or vector object type occurring in the dataset.
    `void` | `setGeometricObjectCount(Integer newValue)` Sets the total number of the point or vector object type occurring in the dataset.
    `void` | `setGeometricObjectType(GeometricObjectType newValue)` Sets the total number of the point or vector object type occurring in the dataset.

    - ### Methods inherited from class ISOMetadata

      `freeze, getIdentifierMap, getIdentifiers, getStandard`

    - ### Methods inherited from class ModifiableMetadata

      `checkWritePermission, clone, collectionType, copyCollection, copyList, copySet, isModifiable, nonNullCollection, nonNullList, nonNullSet, singleton, unmodifiable, writeCollection, writeList, writeSet`

    - ### Methods inherited from class AbstractMetadata

      `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

    - ### Methods inherited from class Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultGeometricObjects

          public DefaultGeometricObjects()

      Constructs an initially empty geometric objects.

    - #### DefaultGeometricObjects

          public DefaultGeometricObjects(GeometricObjectType geometricObjectType)

      Creates a geometric object initialized to the given type.
      Parameters:
        `geometricObjectType` - total number of the point or vector object type occurring in the dataset.

    - #### DefaultGeometricObjects

          public DefaultGeometricObjects(GeometricObjects object)

      Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
      Note on properties validation: This constructor does not verify the property values of the given metadata (e.g. whether it contains unexpected negative values). This is because invalid metadata exist in practice, and verifying their validity in this copy constructor is often too late. Note that this is not the only hole, as invalid metadata instances can also be obtained by unmarshalling an invalid XML document.
      Parameters:
        `object` - the metadata to copy values from, or `null` if none.
      See Also:
        `castOrCopy(GeometricObjects)`

  - ### Method Detail

    - #### castOrCopy

          public static DefaultGeometricObjects castOrCopy(GeometricObjects object)

      Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
      - If the given object is `null`, then this method returns `null`.
      - Otherwise if the given object is already an instance of `DefaultGeometricObjects`, then it is returned unchanged.
      - Otherwise a new `DefaultGeometricObjects` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the object to get as a SIS implementation, or `null` if none.
      Returns:
        a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

    - #### getGeometricObjectType

          public GeometricObjectType getGeometricObjectType()

      Returns the total number of the point or vector object type occurring in the dataset.
      Specified by:
        `getGeometricObjectType` in interface `GeometricObjects`
      Returns:
        name of spatial objects used to locate spatial locations in the dataset, or `null`.

    - #### setGeometricObjectType

          public void setGeometricObjectType(GeometricObjectType newValue)

      Sets the total number of the point or vector object type occurring in the dataset.
      Parameters:
        `newValue` - the new geometric object type.

    - #### getGeometricObjectCount

          @ValueRange(minimum=1.0)
          public Integer getGeometricObjectCount()

      Returns the total number of the point or vector object type occurring in the dataset.
      Specified by:
        `getGeometricObjectCount` in interface `GeometricObjects`
      Returns:
        total number of the point or vector object type, or `null`.

    - #### setGeometricObjectCount

          public void setGeometricObjectCount(Integer newValue)

      Sets the total number of the point or vector object type occurring in the dataset.
      Parameters:
        `newValue` - the geometric object count, or `null`.
      Throws:
        `IllegalArgumentException` - if the given value is zero or negative.

Copyright © 2010–2017 The Apache Software Foundation. All rights reserved.